## ros-kinetic-aws-common 2.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(aws_common)

SET(AWS_COMMON_VERSION 1.0.0)

add_compile_options(-std=c++11)
if (DEFINED ENV{ROS_DISTRO})
    add_definitions(-DCMAKE_ROS_DISTRO="$ENV{ROS_DISTRO}")
else()
    add_definitions(-DCMAKE_ROS_DISTRO="unknown")
endif()
if (DEFINED ENV{ROS_VERSION})
    add_definitions(-DCMAKE_ROS_VERSION="$ENV{ROS_VERSION}")
else()
    add_definitions(-DCMAKE_ROS_VERSION="1")
endif()

include(GNUInstallDirs)
if(NOT EXTERNAL_INSTALL_LOCATION)
  set(EXTERNAL_INSTALL_LOCATION ${CMAKE_BINARY_DIR}/external)
endif()

## Add AWS SDK libraries
set(SERVICE "core" "logs" "monitoring" "s3" "kinesis" "iot" "lex" "polly")
foreach(_service ${SERVICE})
  list(APPEND ${PROJECT_NAME}_IMPORTED_LIBRARIES "aws-cpp-sdk-${_service}")
endforeach()
add_subdirectory(awssdk)

include_directories(include)
## Declare a C++ library
add_library(${PROJECT_NAME} SHARED
  src/sdk_utils/parameter_path.cpp
  src/sdk_utils/aws_profile_provider.cpp
  src/sdk_utils/client_configuration_provider.cpp
  src/sdk_utils/logging/aws_log_system.cpp
  src/sdk_utils/auth/service_credentials_provider.cpp
  src/fs_utils/wordexp_ros.cpp)
add_dependencies(${PROJECT_NAME} AWS_SDK_IMPORT)

foreach(_imported_lib ${${PROJECT_NAME}_IMPORTED_LIBRARIES})
  if(NOT TARGET ${_imported_lib})
    add_library(${_imported_lib} UNKNOWN IMPORTED)
    set_target_properties(${_imported_lib} PROPERTIES
      INTERFACE_INCLUDE_DIRECTORIES "${EXTERNAL_INSTALL_LOCATION}/include")
    set_target_properties(${_imported_lib} PROPERTIES
      IMPORTED_LINK_INTERFACE_LANGUAGES "CXX"
      IMPORTED_LOCATION "${EXTERNAL_INSTALL_LOCATION}/${CMAKE_INSTALL_LIBDIR}/lib${_imported_lib}.so")
    set_property(TARGET ${_imported_lib} APPEND PROPERTY
      IMPORTED_CONFIGURATIONS RELEASE)
  endif()
endforeach()

## Specify libraries to link a library or executable target against
target_link_libraries(${PROJECT_NAME} ${${PROJECT_NAME}_IMPORTED_LIBRARIES})
target_include_directories(${PROJECT_NAME} PRIVATE ${AWSSDK_INCLUDE_DIR})
target_include_directories(${PROJECT_NAME} PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)


#############
### Tests ###
#############
enable_testing()
include(${CMAKE_SOURCE_DIR}/cmake/DefineTestMacros.cmake)
find_common_test_packages()
add_common_gtest(test_aws_log_system test/sdk_utils/logging/aws_log_system_test.cpp)
add_common_gtest(test_throttling_manager test/sdk_utils/throttling_manager_test.cpp)
add_common_gtest(test_client_configuration_provider test/sdk_utils/client_configuration_provider_test.cpp)
add_common_gtest(test_service_credentials_provider test/sdk_utils/auth/service_credentials_provider_test.cpp)
add_common_gtest(test_wordexp_ros test/fs_utils/wordexp_ros_test.cpp)

add_library(test_utils test/sdk_utils/parameter_reader_mock.cpp)
target_include_directories(test_utils PUBLIC ${PROJECT_SOURCE_DIR}/test/include)

set(LIBS_FOR_TESTS
  ${PROJECT_NAME}
  test_utils
  ${aws_common_LIBRARIES}
  ${GMOCK_LIBRARY}
  pthread
)

set(HEADERS_FOR_TESTS
  ${aws_common_INCLUDE_DIRS}
  ${AWSSDK_INCLUDE_DIR}
)

macro(link_test_target target_name)
  if(TARGET ${target_name})
    target_include_directories("${target_name}" PRIVATE ${HEADERS_FOR_TESTS})
    target_link_libraries("${target_name}" ${LIBS_FOR_TESTS})
  endif()
endmacro()

link_test_target(test_aws_log_system)
link_test_target(test_throttling_manager)
link_test_target(test_client_configuration_provider)
link_test_target(test_service_credentials_provider)
link_test_target(test_wordexp_ros)

#############
## Install ##
#############

## Mark executables and/or libraries for installation
install(TARGETS ${PROJECT_NAME}
  EXPORT "${PROJECT_NAME}-targets"
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

## Mark cpp header files for installation
install(
  DIRECTORY include/
  DESTINATION include/
)

export(TARGETS ${PROJECT_NAME}
  FILE "${PROJECT_BINARY_DIR}/${PROJECT_NAME}-targets.cmake")
export(PACKAGE ${PROJECT_NAME})

CONFIGURE_FILE(${PROJECT_NAME}Config.cmake.in
  ${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake @ONLY)
CONFIGURE_FILE(${PROJECT_NAME}ConfigVersion.cmake.in
  ${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake @ONLY)
INSTALL(DIRECTORY ${PROJECT_BINARY_DIR}/external/${CMAKE_INSTALL_LIBDIR}/cmake/AWSSDK/ DESTINATION share/${PROJECT_NAME}/cmake)
INSTALL(FILES ${CMAKE_SOURCE_DIR}/cmake/DefineTestMacros.cmake DESTINATION share/${PROJECT_NAME}/cmake)
INSTALL(FILES ${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake DESTINATION share/${PROJECT_NAME}/cmake)
INSTALL(FILES ${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake DESTINATION share/${PROJECT_NAME}/cmake)
INSTALL(EXPORT ${PROJECT_NAME}-targets DESTINATION share/${PROJECT_NAME}/cmake)

=== debian/changelog ===
ros-kinetic-aws-common (2.2.0-1xenial) xenial; urgency=high

  * Update package.xml
    https://github.com/aws-robotics/utils-common/pull/52 adds a new feature for expanding file paths
  * Fix linting issues found by clang-tidy 6.0 (#53 <https://github.com/aws-robotics/utils-common/issues/53>)
    * fix linter errors
    * fix more linter errors
    * add linter exceptions
    * address PR comments
  * Add wordexp_ros wrapper for wordexp, allowing ROS-aware path expansion
  * Add buildtool dependency on ament_cmake_gtest/gmock
  * Update DefineTestMacros.cmake
  * Add NoRetryStrategy (#38 <https://github.com/aws-robotics/utils-common/issues/38>)
    * ROS-2222: Add Configuration For Retry Strategy
    cr https://code.amazon.com/reviews/CR-10006070
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Don't allow max_retries to override strategy
    cr https://code.amazon.com/reviews/CR-10283519
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * cleanup NoRetryStrategy
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * increment minor version
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
  * Fix ament macro call in DefineTestMacros.cmake (#35 <https://github.com/aws-robotics/utils-common/issues/35>)
    * Fix ament macro call in DefineTestMacros.cmake
    * Disallow Travis build failures for dashing
  * Add macro for ros1/2 finding gtest and gmock (#30 <https://github.com/aws-robotics/utils-common/issues/30>)
    * Add macro for ros1/2 finding gtest and gmock
    The macro find_common_test_packages will use ament or catkin to link to gtest and gmock libraries.
    **Note:** You must add dependencies on gtest and gmock in the package.xml still
    * remove linkage against redundant library
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * update travis.yml to be compatible with specifying multiple package names
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * update travis.yml test matrix
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * make catkin a buildtool_depend
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
  * Contributors: AAlon, Avishay Alon, M. M, Miaofei Mei, Ross Desmond, Ryan Newell

 -- AWS RoboMaker <ros-contributions@amazon.com>  Fri, 27 Mar 2020 00:00:00 -0000

ros-kinetic-aws-common (2.0.0-1xenial) xenial; urgency=high

  * Add ROS2 dependencies to package.xml (#21 <https://github.com/aws-robotics/utils-common/issues/21>)
    * Update package.xml to depend on ament_cmake_gtest and ament_cmake_gmock if building for ROS2.
  * Disallow use of non-ParameterPath objects in ParameterReaderInterface (#19 <https://github.com/aws-robotics/utils-common/issues/19>)
  * Remove legacy portions of the ParameterReader API (#18 <https://github.com/aws-robotics/utils-common/issues/18>)
    * remove lunar travis builds
    * remove legacy portions of the ParameterReader API
  * Update ParameterReader API to support ROS1/ROS2 (#17 <https://github.com/aws-robotics/utils-common/issues/17>)
    * cleanup CMakeFiles
    * refactor using the new ParameterReader API
    * clean up design of ParameterPath object
  * Fix tests not running & optimize build time (#13 <https://github.com/aws-robotics/utils-common/issues/13>)
  * Merge pull request #9 <https://github.com/aws-robotics/utils-common/issues/9> from xabxx/master
    fixed throttling manager unit test bug
  * Update local variable name to class member name
    throttled_function_call_count -> throttled_function_call_count_
  * Improve test coverage
  * fixed throttling manager unit test bug
  * Contributors: AAlon, Abby Xu, M. M, Ross Desmond, hortala

 -- AWS RoboMaker <ros-contributions@amazon.com>  Mon, 25 Feb 2019 00:00:00 -0000

=== debian/control ===
Source: ros-kinetic-aws-common
Section: misc
Priority: optional
Maintainer: AWS RoboMaker <ros-contributions@amazon.com>
Build-Depends: debhelper (>= 9.0.0), cmake, curl, google-mock, libcurl4-openssl-dev, libgtest-dev, libssl-dev, ros-kinetic-catkin, ros-kinetic-ros-environment, uuid-dev, zlib1g-dev
Homepage: http://wiki.ros.org/aws_common
Standards-Version: 3.9.2

Package: ros-kinetic-aws-common
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, curl, libcurl4-openssl-dev, libssl-dev, uuid-dev, zlib1g-dev
Description: Common AWS SDK utilities, intended for use by ROS packages using the AWS SDK

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-aws-common//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
